<template>
  <div >
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="链接名称" prop="name">
        <el-input
          v-model="queryParams.name"
          placeholder="请输入链接名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>

      <el-form-item label="标题" prop="title">
        <el-input
          v-model="queryParams.title"
          placeholder="请输入标题"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="创建时间" prop="createTime">
        <el-date-picker clearable size="small"
          v-model="queryParams.createTime"
          type="date"
          value-format="yyyy-MM-dd"
          placeholder="选择创建时间">
        </el-date-picker>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['qw:drainageLink:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['qw:drainageLink:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['qw:drainageLink:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          :loading="exportLoading"
          @click="handleExport"
          v-hasPermi="['qw:drainageLink:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="drainageLinkList" @selection-change="handleSelectionChange" border>
      <el-table-column type="selection" width="55" align="center" />

      <el-table-column label="链接名称" align="center" prop="name" />

      <el-table-column label="群聊二维码" align="center" prop="qrCode" width="150px">
        <template slot-scope="scope">
          <el-popover
            placement="right"
            title=""
            trigger="hover">
            <img slot="reference" :src="scope.row.qrCode" width="100px">
            <img :src="scope.row.qrCode" style="max-width: 350px;">
          </el-popover>
        </template>
      </el-table-column>

      <el-table-column label="标题" align="center" prop="title" />
      <el-table-column label="显示昵称" align="center" prop="nickName" />
      <el-table-column label="联系电话" align="center" prop="phone" />
      <el-table-column label="点击数" align="center" prop="clickNum" />
      <el-table-column label="添加人数" align="center" prop="addNum" />
      <el-table-column label="创建时间" align="center" prop="createTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.createTime, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="创建人" align="center" prop="createBy" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" fixed="right" width="170px">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['qw:drainageLink:edit']"
          >修改</el-button>
          <el-button
             size="mini"
             type="text"
             @click="handledetails(scope.row)"
             >数据统计
          </el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['qw:drainageLink:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改引流链接对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="600px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="名称" prop="name">
          <el-input v-model="form.name" placeholder="请输入链接名称" />
        </el-form-item>
        <el-form-item label="入群链接" prop="qrCode" >
          <el-upload
             v-model="form.qrCode"
             class="avatar-uploader"
             :action="uploadUrl"
             :show-file-list="false"
             :on-success="handleAvatarSuccess2"
             :before-upload="beforeAvatarUpload">
             <img v-if="form.qrCode" :src="form.qrCode" class="avatar" width="300px">
             <i v-else class="el-icon-plus avatar-uploader-icon"></i>
          </el-upload>

        </el-form-item>

        <el-form-item label="标题" prop="title">
          <el-input v-model="form.title" placeholder="请输入标题" />
        </el-form-item>
        <el-form-item label="昵称" prop="nickName">
          <el-input v-model="form.nickName" placeholder="请输入昵称" />
        </el-form-item>
        <el-form-item label="联系电话" prop="phone">
          <el-input v-model="form.phone" placeholder="请输入联系电话" />
        </el-form-item>
        <el-form-item label="企业名称" prop="companyName">
          <el-input v-model="form.companyName" placeholder="请输入企业名称" />
        </el-form-item>
        <el-form-item label="企业头像" prop="avatarUrl">
          <el-upload
             v-model="form.avatarUrl"
             class="avatar-uploader"
             :action="uploadUrl"
             :show-file-list="false"
             :on-success="handleAvatarSuccess"
             :before-upload="beforeAvatarUpload">
             <img v-if="form.avatarUrl" :src="form.avatarUrl" class="avatar" width="300px">
             <i v-else class="el-icon-plus avatar-uploader-icon"></i>
          </el-upload>
        </el-form-item>
        <el-form-item label="文案">
          <el-input v-model="form.content" placeholder="文案" type="textarea"/>

        </el-form-item>

      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <el-drawer
         :with-header="false"
         size="75%"
         :title="show.title" :visible.sync="show.open">
      <statisDetails  ref="Details" />
    </el-drawer>
  </div>
</template>

<script>
import { listDrainageLink, getDrainageLink, delDrainageLink, addDrainageLink, updateDrainageLink, exportDrainageLink } from "@/api/qw/drainageLink";
import { listContactWay} from "@/api/qw/contactWay";
import statisDetails from '@/views/qw/drainageLink/statisDetails.vue'
export default {
  name: "DrainageLink",
    components: { statisDetails},
  data() {
    return {
      show:{
              title:"数据统计",
              open:false,
            },
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      uploadUrl:process.env.VUE_APP_BASE_API+"/common/uploadOSS",
      baseUrl: process.env.VUE_APP_BASE_API,
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 引流链接表格数据
      drainageLinkList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        name: null,
        wayId: null,
        title: null,
        nickName: null,
        phone: null,
        companyName: null,
        createTime: null,
        createBy: null,
        type:2
      },
      // 表单参数
      form: {},
      WayList:[],
      // 表单校验
      rules: {
        name:[{required: true, message: "引流链接名称不能为空", trigger: "blur"}],

        wayId:[{required: true, message: "渠道活码不能为空", trigger: "change"}],

        title:[{required: true, message: "标题不能为空", trigger: "blur"}],


      }
    };
  },
  created() {
    this.getList();
    listContactWay().then(response => {
        this.WayList = response.rows;
      });
  },
  methods: {
    /** 查询引流链接列表 */
    getList() {
      this.loading = true;
      listDrainageLink(this.queryParams).then(response => {
        this.drainageLinkList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    handledetails(row){
             this.show.open=true;
             setTimeout(() => {
                  this.$refs.Details.getDetails(row.id);
             }, 1);
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        name: null,
        wayId: null,
        qrCode: null,
        linkUrl: null,
        title: null,
        nickName: null,
        phone: null,
        companyName: null,
        avatarUrl: null,
        content: null,
        clickNum: null,
        addNum: null,
        createTime: null,
        createBy: null,
        type:2
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加引流链接";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getDrainageLink(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改引流链接";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          this.form.type=2;
          if (this.form.id != null) {
            updateDrainageLink(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addDrainageLink(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除引流链接编号为"' + ids + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delDrainageLink(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    handleAvatarSuccess(res, file) {
        if(res.code==200){
          this.form.avatarUrl=res.url;
          self.$forceUpdate()
        }
        else{
          this.msgError(res.msg);
        }
    },
    handleAvatarSuccess2(res, file) {
        if(res.code==200){
          this.form.qrCode=res.url;
          self.$forceUpdate()
        }
        else{
          this.msgError(res.msg);
        }
    },

    beforeAvatarUpload(file) {
      const isLt1M = file.size / 1024 / 1024 < 1;
      if (!isLt1M) {
        this.$message.error('上传图片大小不能超过 1MB!');
      }
      return   isLt1M;
    },

    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有引流链接数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.exportLoading = true;
          return exportDrainageLink(queryParams);
        }).then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        }).catch(() => {});
    }
  }
};
</script>
<style scoped>

.avatar-uploader .el-upload {
   border: 1px dashed #d9d9d9;
   border-radius: 6px;
   cursor: pointer;
   position: relative;
   overflow: hidden;
 }
 .avatar-uploader .el-upload:hover {
   border-color: #409EFF;
 }

 .avatar-uploader-icon {
   font-size: 28px;
   color: #8c939d;
   width: 150px;
   height: 150px;
   line-height: 150px;
   text-align: center;
 }
</style>
